import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;

public class Morpion {
	
	int				l;
	int				c;
	String			login1			= "J1";
	String			login2			= "J2";
	int				score1			= 0;
	int				score2			= 0;
	int				egal			= 0;
	JFrame			fen				= new JFrame("Morpion");
	Container		contenu			= fen.getContentPane();
	int				alt;
	Bouton[][]		but				= new Bouton[3][3];
	JFrame			jeu				= new JFrame();
	int				nb				= 2;
	String			symb1;
	String			symb2;
	int				sauv;
	int				typepartie;
	final JFrame	princip			= new JFrame("Saisie");
	int				ajoue			= 0;
	int				affgagnant		= 0;
	
	/*
	 * ImageIcon imageMorpion=new ImageIcon("images/morpion.jpg"); ImageIcon imageSimpson=new
	 * ImageIcon("images/simpson1.gif"); ImageIcon imageCreateur=new ImageIcon("images/createur.jpg"); ImageIcon
	 * imagePodium=new ImageIcon("images/podium.gif");
	 */

	ImageIcon		imageMorpion	= new ImageIcon("images/morpion.jpg");
	ImageIcon		imageSimpson	= new ImageIcon("images/simpson1.jpg");
	ImageIcon		imageCreateur	= new ImageIcon("images/createur.jpg");
	ImageIcon		imagePodium		= new ImageIcon("images/podium.gif");
	
	public void setaleatoire() throws InterruptedException {

		int i;
		int i2;
		int cpt = 0;
		
		while (cpt != 1) {
			i = (int) (Math.random() * 3);
			i2 = (int) (Math.random() * 3);
			
			if (but[i][i2].estVide) {
				
				but[i][i2].setRond();
				Thread.sleep(100);
				but[i][i2].estVide = false;
				
				cpt = 1;
			} else if (but[i2][i].estVide) {
				
				but[i2][i].setRond();
				Thread.sleep(100);
				but[i2][i].estVide = false;
				cpt = 1;
			} else {
				
			}
		}
	}
	
	public void init(int imalt) throws InterruptedException {

		ajoue = 0;
		affgagnant = 0;
		if (imalt == 1) {
			alt = 1;
		} else if (imalt == 2) {
			alt = 2;
		}
		if (imalt != 3) {
			try {
				Thread.sleep(200);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			jeu.dispose();
			jeu = new JFrame();
			Container con = jeu.getContentPane();
			con.setLayout(new GridBagLayout());
			GridBagConstraints contraint = new GridBagConstraints();
			contraint.fill = contraint.BOTH;
			jeu.setBounds(300, 300, 200, 200);
			if (nb == 3) {
				jeu.setBounds(350, 350, 500, 500);
			}
			contraint.weightx = 1;
			contraint.weighty = 1;
			contraint.gridx = 0;
			contraint.gridy = 0;
			contraint.anchor = contraint.CENTER;
			for (l = 0; l <= nb; l++) {
				contraint.gridy = l;
				for (c = 0; c <= nb; c++) {
					contraint.gridx = c;
					but[l][c] = new Bouton();
					but[l][c].button = new JButton();
					if (nb == 2) {
						but[l][c].button.setPreferredSize(new Dimension(100, 100));
						but[l][c].button.setMinimumSize(new Dimension(100, 100));
					} else {
						but[l][c].button.setPreferredSize(new Dimension(300, 300));
						but[l][c].button.setMinimumSize(new Dimension(300, 300));
					}
					but[l][c].estVide = true;
					con.add(but[l][c].button, contraint);
					
				}
				
			}
			
			but[0][0].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[0][0].setCroix();
						alt = 2;
					} else {
						
						but[0][0].setRond();
						alt = 1;
					}
					but[0][0].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[0][1].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[0][1].setCroix();
						alt = 2;
					} else {
						
						but[0][1].setRond();
						alt = 1;
					}
					but[0][1].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[0][2].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[0][2].setCroix();
						alt = 2;
					} else {
						
						but[0][2].setRond();
						alt = 1;
					}
					but[0][2].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[1][0].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[1][0].setCroix();
						alt = 2;
					} else {
						
						but[1][0].setRond();
						alt = 1;
					}
					but[1][0].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[1][1].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[1][1].setCroix();
						alt = 2;
					} else {
						
						but[1][1].setRond();
						alt = 1;
					}
					but[1][1].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[1][2].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[1][2].setCroix();
						alt = 2;
					} else {
						
						but[1][2].setRond();
						alt = 1;
					}
					but[1][2].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[2][0].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[2][0].setCroix();
						alt = 2;
					} else {
						
						but[2][0].setRond();
						alt = 1;
					}
					but[2][0].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[2][1].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[2][1].setCroix();
						alt = 2;
					} else {
						
						but[2][1].setRond();
						alt = 1;
					}
					but[2][1].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			but[2][2].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					if (alt == 1) {
						
						but[2][2].setCroix();
						alt = 2;
					} else {
						
						but[2][2].setRond();
						alt = 1;
					}
					but[2][2].button.removeMouseListener(this);
					if (!gagnant().equals("")) {
						try {
							affgagner(gagnant());
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
					}
					
				}
				
			});
			
			if (nb == 3) {
				
				but[0][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[0][3].setCroix();
							alt = 2;
						} else {
							
							but[0][3].setRond();
							alt = 1;
						}
						but[0][3].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
				but[1][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[1][3].setCroix();
							alt = 2;
						} else {
							
							but[1][3].setRond();
							alt = 1;
						}
						but[1][3].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
				but[2][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[2][3].setCroix();
							alt = 2;
						} else {
							
							but[2][3].setRond();
							alt = 1;
						}
						but[2][3].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
				but[3][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[3][3].setCroix();
							alt = 2;
						} else {
							
							but[3][3].setRond();
							alt = 1;
						}
						but[3][3].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
				but[3][0].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[3][0].setCroix();
							alt = 2;
						} else {
							
							but[3][0].setRond();
							alt = 1;
						}
						but[3][0].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
				but[3][1].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[3][1].setCroix();
							alt = 2;
						} else {
							
							but[3][1].setRond();
							alt = 1;
						}
						but[3][1].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
				but[3][2].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						if (alt == 1) {
							
							but[3][2].setCroix();
							alt = 2;
						} else {
							
							but[3][2].setRond();
							alt = 1;
						}
						but[3][2].button.removeMouseListener(this);
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
						
					}
					
				});
				
			}
			
			jeu.setVisible(true);
			jeu.setBounds(contenu.getBounds());
			
		} else {
			// Ordinateur
			login2 = "Ordinateur";
			
			jeu = new JFrame();
			
			Container con = jeu.getContentPane();
			con.setLayout(new GridBagLayout());
			GridBagConstraints contraint = new GridBagConstraints();
			contraint.fill = contraint.BOTH;
			jeu.setBounds(300, 300, 200, 200);
			if (nb == 3) {
				jeu.setBounds(350, 350, 500, 500);
			}
			contraint.weightx = 1;
			contraint.weighty = 1;
			contraint.gridx = 0;
			contraint.gridy = 0;
			contraint.anchor = contraint.CENTER;
			for (l = 0; l <= nb; l++) {
				contraint.gridy = l;
				for (c = 0; c <= nb; c++) {
					contraint.gridx = c;
					but[l][c] = new Bouton();
					but[l][c].button = new JButton();
					if (nb == 2) {
						but[l][c].button.setPreferredSize(new Dimension(100, 100));
						but[l][c].button.setMinimumSize(new Dimension(100, 100));
					} else {
						but[l][c].button.setPreferredSize(new Dimension(300, 300));
						but[l][c].button.setMinimumSize(new Dimension(300, 300));
					}
					but[l][c].estVide = true;
					con.add(but[l][c].button, contraint);
					
				}
				
			}
			
			but[0][0].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[0][0].estVide) {
						but[0][0].setCroix();
						ajoue = 1;
						if (!gagnant().equals("")) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[0][0].button.removeMouseListener(this);
					
				}
				
			});
			
			but[0][1].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[0][1].estVide) {
						but[0][1].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[0][1].button.removeMouseListener(this);
					
				}
				
			});
			
			but[0][2].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[0][2].estVide) {
						but[0][2].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[0][2].button.removeMouseListener(this);
					
				}
				
			});
			
			but[1][0].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[1][0].estVide) {
						but[1][0].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[1][0].button.removeMouseListener(this);
					
				}
				
			});
			
			but[1][1].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[1][1].estVide) {
						but[1][1].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[1][1].button.removeMouseListener(this);
					
				}
				
			});
			
			but[1][2].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[1][2].estVide) {
						but[1][2].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[1][2].button.removeMouseListener(this);
					
				}
				
			});
			
			but[2][0].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[2][0].estVide) {
						but[2][0].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[2][0].button.removeMouseListener(this);
					
				}
				
			});
			
			but[2][1].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[2][1].estVide) {
						but[2][1].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[2][1].button.removeMouseListener(this);
					
				}
				
			});
			
			but[2][2].button.addMouseListener(new MouseAdapter() {
				
				public void mousePressed(MouseEvent e) {

					while (but[2][2].estVide) {
						but[2][2].setCroix();
						ajoue = 1;
						if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					}
					try {
						
						if (ajoue == 1 && gagnant().equals("")) {
							setaleatoire();
						} else if (!gagnant().equals("") && affgagnant == 0) {
							try {
								affgagner(gagnant());
								affgagnant = 1;
							} catch (InterruptedException e1) {
								// TODO Auto-generated catch block
								e1.printStackTrace();
							}
						}
					} catch (InterruptedException e1) {
						// TODO Auto-generated catch block
						e1.printStackTrace();
					}
					
					ajoue = 0;
					but[2][2].button.removeMouseListener(this);
					
				}
				
			});
			
			if (nb == 3) {
				but[0][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[0][3].estVide) {
							but[0][3].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
							
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[0][3].button.removeMouseListener(this);
						
					}
					
				});
				
				but[1][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[1][3].estVide) {
							but[1][3].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[1][3].button.removeMouseListener(this);
						
					}
					
				});
				
				but[2][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[2][3].estVide) {
							but[2][3].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[2][3].button.removeMouseListener(this);
						
					}
					
				});
				
				but[3][3].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[3][3].estVide) {
							but[3][3].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[3][3].button.removeMouseListener(this);
						
					}
					
				});
				
				but[3][0].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[3][0].estVide) {
							but[3][0].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[3][0].button.removeMouseListener(this);
						
					}
					
				});
				
				but[3][1].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[3][1].estVide) {
							but[3][1].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[3][1].button.removeMouseListener(this);
						
					}
					
				});
				
				but[3][2].button.addMouseListener(new MouseAdapter() {
					
					public void mousePressed(MouseEvent e) {

						while (but[3][2].estVide) {
							but[3][2].setCroix();
							ajoue = 1;
							if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						}
						try {
							
							if (ajoue == 1 && gagnant().equals("")) {
								setaleatoire();
							} else if (!gagnant().equals("") && affgagnant == 0) {
								try {
									affgagner(gagnant());
									affgagnant = 1;
								} catch (InterruptedException e1) {
									// TODO Auto-generated catch block
									e1.printStackTrace();
								}
							}
						} catch (InterruptedException e1) {
							// TODO Auto-generated catch block
							e1.printStackTrace();
						}
						
						ajoue = 0;
						but[3][2].button.removeMouseListener(this);
						
					}
					
				});
				
			}
			
			jeu.setVisible(true);
			jeu.setBounds(contenu.getBounds());
			
		}
		
	}
	
	public String gagnant() {

		String p = "";
		if (but.length == 3) {
			if ((this.but[0][0].estCroix && this.but[0][1].estCroix && this.but[0][2].estCroix)
				|| (this.but[1][0].estCroix && this.but[1][1].estCroix && this.but[1][2].estCroix)
				|| (this.but[2][0].estCroix && this.but[2][1].estCroix && this.but[2][2].estCroix)
				|| (this.but[0][0].estCroix && this.but[1][0].estCroix && this.but[2][0].estCroix)
				|| (this.but[0][1].estCroix && this.but[1][1].estCroix && this.but[2][1].estCroix)
				|| (this.but[0][2].estCroix && this.but[1][2].estCroix && this.but[2][2].estCroix)
				|| (this.but[0][0].estCroix && this.but[1][1].estCroix && this.but[2][2].estCroix)
				|| (this.but[0][2].estCroix && this.but[1][1].estCroix && this.but[2][0].estCroix)) {
				p = "1";
			} else if ((this.but[0][0].estRond && this.but[0][1].estRond && this.but[0][2].estRond)
						|| (this.but[1][0].estRond && this.but[1][1].estRond && this.but[1][2].estRond)
						|| (this.but[2][0].estRond && this.but[2][1].estRond && this.but[2][2].estRond)
						|| (this.but[0][0].estRond && this.but[1][0].estRond && this.but[2][0].estRond)
						|| (this.but[0][1].estRond && this.but[1][1].estRond && this.but[2][1].estRond)
						|| (this.but[0][2].estRond && this.but[1][2].estRond && this.but[2][2].estRond)
						|| (this.but[0][0].estRond && this.but[1][1].estRond && this.but[2][2].estRond)
						|| (this.but[0][2].estRond && this.but[1][1].estRond && this.but[2][0].estRond)) {
				p = "2";
			} else if (!this.but[0][0].estVide && !this.but[0][1].estVide && !this.but[0][2].estVide && !this.but[1][0].estVide
						&& !this.but[1][1].estVide && !this.but[1][2].estVide && !this.but[2][0].estVide
						&& !this.but[2][1].estVide && !this.but[2][2].estVide) {
				p = "Egalit";
			} else {
				p = "";
			}
		} else if (but.length == 4) {
			if ((this.but[0][0].estCroix && this.but[0][1].estCroix && this.but[0][2].estCroix && this.but[0][3].estCroix)
				|| (this.but[1][0].estCroix && this.but[1][1].estCroix && this.but[1][2].estCroix && this.but[1][3].estCroix)
				|| (this.but[2][0].estCroix && this.but[2][1].estCroix && this.but[2][2].estCroix && this.but[2][3].estCroix)
				|| (this.but[0][0].estCroix && this.but[1][0].estCroix && this.but[2][0].estCroix && this.but[3][0].estCroix)
				|| (this.but[0][1].estCroix && this.but[1][1].estCroix && this.but[2][1].estCroix && this.but[3][1].estCroix)
				|| (this.but[0][2].estCroix && this.but[1][2].estCroix && this.but[2][2].estCroix && this.but[3][2].estCroix)
				|| (this.but[0][0].estCroix && this.but[1][1].estCroix && this.but[2][2].estCroix && this.but[3][3].estCroix)
				|| (this.but[3][0].estCroix && this.but[2][1].estCroix && this.but[1][2].estCroix && this.but[0][3].estCroix)
				|| (this.but[0][3].estCroix && this.but[1][3].estCroix && this.but[2][3].estCroix && this.but[3][3].estCroix)) {
				p = "1";
			} else if (((this.but[0][0].estRond && this.but[0][1].estRond && this.but[0][2].estRond && this.but[0][3].estRond)
						|| (this.but[1][0].estRond && this.but[1][1].estRond && this.but[1][2].estRond && this.but[1][3].estRond)
						|| (this.but[2][0].estRond && this.but[2][1].estRond && this.but[2][2].estRond && this.but[2][3].estRond)
						|| (this.but[0][0].estRond && this.but[1][0].estRond && this.but[2][0].estRond && this.but[3][0].estRond)
						|| (this.but[0][1].estRond && this.but[1][1].estRond && this.but[2][1].estRond && this.but[3][1].estRond)
						|| (this.but[0][2].estRond && this.but[1][2].estRond && this.but[2][2].estRond && this.but[3][2].estRond)
						|| (this.but[0][0].estRond && this.but[1][1].estRond && this.but[2][2].estRond && this.but[3][3].estRond)
						|| (this.but[3][0].estRond && this.but[2][1].estRond && this.but[1][2].estRond && this.but[0][3].estRond) || (this.but[0][0].estRond
																																		&& this.but[0][1].estRond
																																		&& this.but[0][2].estRond && this.but[0][3].estRond))) {
				p = "2";
			} else if (!this.but[0][0].estVide && !this.but[0][1].estVide && !this.but[0][2].estVide && !this.but[0][3].estVide
						&& !this.but[1][0].estVide && !this.but[1][1].estVide && !this.but[1][2].estVide
						&& !this.but[1][3].estVide && !this.but[2][0].estVide && !this.but[2][1].estVide
						&& !this.but[2][2].estVide && !this.but[2][3].estVide && !this.but[0][0].estVide
						&& !this.but[1][0].estVide && !this.but[2][0].estVide && !this.but[3][0].estVide
						&& !this.but[0][1].estVide && !this.but[1][1].estVide && !this.but[2][1].estVide
						&& !this.but[3][1].estVide && !this.but[0][2].estVide && !this.but[1][2].estVide
						&& !this.but[2][2].estVide && !this.but[3][2].estVide && !this.but[0][0].estVide
						&& !this.but[1][1].estVide && !this.but[2][2].estVide && !this.but[3][3].estVide
						&& !this.but[3][0].estVide && !this.but[2][1].estVide && !this.but[1][2].estVide
						&& !this.but[0][3].estVide) {
				p = "Egalit";
			} else {
				p = "";
			}
		}
		return p;
	}
	
	public void affgagner(String gagnant) throws InterruptedException {

		JOptionPane continuer = new JOptionPane();
		int i;
		if (gagnant.equals("1")) {
			i = continuer.showConfirmDialog(fen, login1 + " a gagn la partie ! \nVoulez vous rejouer ?", "Gagn !", JOptionPane.YES_NO_OPTION);
			score1 = score1 + 1;
			if (i == JOptionPane.OK_OPTION) {
				jeu.dispose();
				if (typepartie == 3) {
					init(3);
				} else {
					init(sauv);
				}
			}
		} else if (gagnant.equals("2")) {
			i = continuer.showConfirmDialog(fen, login2 + " a gagn la partie !  \nVoulez vous rejouer ?", "Gagn !", JOptionPane.YES_NO_OPTION);
			score2 = score2 + 1;
			if (i == JOptionPane.OK_OPTION) {
				
				jeu.dispose();
				if (typepartie == 3) {
					init(3);
				} else {
					init(sauv);
				}
			}
		} else if (gagnant.equals("Egalit")) {
			i = continuer.showConfirmDialog(fen, "Egalit, personne n'a gagn la partie !  \nVoulez vous rejouer ?", "Egalit", JOptionPane.YES_NO_OPTION);
			egal = egal + 1;
			if (i == JOptionPane.OK_OPTION) {
				
				jeu.dispose();
				if (typepartie == 3) {
					init(3);
				} else {
					init(sauv);
				}
			}
		} else {
			i = 0;
		}
		
		if (i == JOptionPane.NO_OPTION) {
			
			jeu.dispose();
		} else {
			
		}
		
	}
	
	public static void main(String[] args) {

		final Morpion morpion = new Morpion();
		JLabel texte = new JLabel("Bienvenue dans le jeu du Morpion !");
		morpion.fen.setBounds(500, 200, 900, 800);
		morpion.contenu.setLayout(new GridBagLayout());
		GridBagConstraints contrainte = new GridBagConstraints();
		JMenuBar barre = new JMenuBar();
		JMenu fichier = new JMenu("Nouvelle Partie");
		JMenu about = new JMenu("A propos de");
		JMenuItem regles = new JMenuItem("R̬gles du jeu");
		JMenuItem nouvelle = new JMenuItem("1 Joueur");
		JMenuItem nouvelle2 = new JMenuItem("2 Joueurs");
		JMenuItem scores = new JMenuItem("Scores");
		JMenuItem propos = new JMenuItem("Copyright");
		
		JLabel image1 = new JLabel(morpion.imageMorpion);
		final JOptionPane boite = new JOptionPane();
		morpion.alt = 1;
		
		barre.add(fichier);
		fichier.add(nouvelle);
		fichier.add(nouvelle2);
		fichier.add(scores);
		about.add(regles);
		about.add(propos);
		barre.add(about);
		
		morpion.fen.setJMenuBar(barre);
		
		texte.setFont(new Font("Arial", Font.PLAIN, 20));
		morpion.fen.setBackground(Color.WHITE);
		contrainte.weighty = 1;
		contrainte.weightx = 1;
		contrainte.insets = new Insets(20, 0, 0, 0);
		
		contrainte.gridwidth = GridBagConstraints.REMAINDER;
		contrainte.anchor = GridBagConstraints.PAGE_START;
		
		morpion.contenu.add(texte, contrainte);
		
		morpion.contenu.add(image1, contrainte);
		
		ActionListener saisienom = new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {

				morpion.typepartie = 2;
				
				// Image
				final JLabel label1;
				final JLabel label2;
				JLabel icon;
				final JLabel symbolelabel1;
				final JLabel symbolelabel2;
				final JComboBox symbolej1;
				final JComboBox symbolej2;
				final JTextField nomj1;
				final JTextField nomj2;
				icon = new JLabel(morpion.imageSimpson);
				final JPanel panIcon = new JPanel();
				panIcon.setBackground(Color.white);
				panIcon.setLayout(new BorderLayout());
				panIcon.add(icon);
				
				morpion.princip.setBounds(450, 200, 550, 420);
				
				// Nom Joueur 1
				JPanel panNom = new JPanel();
				panNom.setBackground(Color.white);
				panNom.setPreferredSize(new Dimension(240, 80));
				nomj1 = new JTextField();
				nomj1.setPreferredSize(new Dimension(100, 25));
				panNom.setBorder(BorderFactory.createTitledBorder("Nom du joueur"));
				label1 = new JLabel("Joueur 1, saisissez un nom : ");
				panNom.add(label1);
				panNom.add(nomj1);
				
				// Symbole Joueur 1
				JPanel panSexe = new JPanel();
				panSexe.setBackground(Color.white);
				panSexe.setPreferredSize(new Dimension(240, 80));
				panSexe.setBorder(BorderFactory.createTitledBorder("Symbole Joueur"));
				symbolej1 = new JComboBox();
				symbolej1.addItem("Croix : X");
				symbolej1.addItem("Rond : O");
				symbolej1.addItem("Alatoire");
				symbolelabel1 = new JLabel("Symbole Joueur 1 : ");
				panSexe.add(symbolelabel1);
				panSexe.add(symbolej1);
				
				// Nom Joueur 2
				JPanel panTaille = new JPanel();
				panTaille.setBackground(Color.white);
				panTaille.setPreferredSize(new Dimension(240, 80));
				panTaille.setBorder(BorderFactory.createTitledBorder("Nom du joueur"));
				label2 = new JLabel("Joueur 2, saisissez un nom : ");
				
				nomj2 = new JTextField("");
				nomj2.setPreferredSize(new Dimension(90, 25));
				panTaille.add(label2);
				panTaille.add(nomj2);
				
				// Symbole Joueur 2
				JPanel panCheveux = new JPanel();
				panCheveux.setBackground(Color.white);
				panCheveux.setPreferredSize(new Dimension(240, 80));
				panCheveux.setBorder(BorderFactory.createTitledBorder("Symbole Joueur"));
				symbolej2 = new JComboBox();
				symbolej2.addItem("Croix : X");
				symbolej2.addItem("Rond : O");
				symbolej2.addItem("Alatoire");
				symbolelabel2 = new JLabel("Symbole Joueur 2 : ");
				panCheveux.add(symbolelabel2);
				panCheveux.add(symbolej2);
				
				JPanel content = new JPanel();
				content.setBackground(Color.white);
				content.add(panNom);
				content.add(panSexe);
				content.add(panTaille);
				content.add(panCheveux);
				
				JPanel control = new JPanel();
				JButton okBouton = new JButton("OK");
				
				JButton cancelBouton = new JButton("Annuler");
				control.add(okBouton);
				control.add(cancelBouton);
				
				morpion.princip.getContentPane().add(panIcon, BorderLayout.WEST);
				morpion.princip.getContentPane().add(content, BorderLayout.CENTER);
				morpion.princip.getContentPane().add(control, BorderLayout.SOUTH);
				
				morpion.princip.setVisible(true);
				morpion.princip.setDefaultCloseOperation(morpion.princip.DISPOSE_ON_CLOSE);
				
				if (morpion.login1.equals("")) {
					morpion.login1 = "Inconnu1";
				} else if (morpion.login2.equals("")) {
					morpion.login2 = "Inconnu2";
				}
				
				cancelBouton.addActionListener(new ActionListener() {
					
					public void actionPerformed(ActionEvent arg0) {

						morpion.princip.setVisible(false);
					}
				});
				
				okBouton.addActionListener(new ActionListener() {
					
					public void actionPerformed(ActionEvent arg0) {

						morpion.login1 = nomj1.getText();
						morpion.login2 = nomj2.getText();
						
						morpion.symb1 = (String) symbolej1.getSelectedItem();
						morpion.symb2 = (String) symbolej2.getSelectedItem();
						if (morpion.symb1.equals("Croix : X")) {
							try {
								morpion.init(1);
								morpion.sauv = 1;
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						} else if (morpion.symb1.equals("Rond : O")) {
							try {
								morpion.init(2);
								morpion.sauv = 2;
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						} else {
							try {
								morpion.init(0);
							} catch (InterruptedException e) {
								// TODO Auto-generated catch block
								e.printStackTrace();
							}
						}
						morpion.princip.dispose();
						
					}
				});
				
			}
			
		};
		
		nouvelle2.addActionListener(saisienom);
		
		ActionListener solo = new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {

				JOptionPane info = new JOptionPane();
				morpion.login1 = info.showInputDialog(morpion.fen, "Choisissez un nom de Joueur : ", "");
				if (morpion.login1 == "") {
					morpion.login1 = "Inconnu 1";
				}
				try {
					morpion.typepartie = 3;
					morpion.init(3);
					morpion.typepartie = 2;
				} catch (InterruptedException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		};
		
		nouvelle.addActionListener(solo);
		
		ActionListener copyright = new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {

				JOptionPane info = new JOptionPane();
				info.showMessageDialog(morpion.fen, "Auteur : Juju \nVersion : 1.0\nLicence : Freeware\nCopyright : weillaert.julien@live.fr", "Informations", JOptionPane.INFORMATION_MESSAGE, morpion.imageCreateur);
			}
		};
		
		propos.addActionListener(copyright);
		
		ActionListener regledujeu = new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {

				JOptionPane reglesdujeu = new JOptionPane();
				reglesdujeu.showMessageDialog(morpion.fen, "Principe du jeu :\n\n-Chaque joueur pose une croix ou un rond\n-De fa̤on  obtenir une ligne de trois croix ou trois rond\n-Le premier ayant une ligne a gagn\n-La ligne peut ̻tre horizontal, verticale ou en diagonale", "R̬gles du Jeu", JOptionPane.INFORMATION_MESSAGE);
			}
		};
		
		regles.addActionListener(regledujeu);
		
		ActionListener fenscore = new ActionListener() {
			
			public void actionPerformed(ActionEvent e) {

				JOptionPane info = new JOptionPane();
				info.showMessageDialog(morpion.fen, "Scores : \n" + " " + "\n" + morpion.login1 + " : " + morpion.score1
													+ " pts \n" + morpion.login2 + " : " + morpion.score2 + " pts", "Scores", JOptionPane.INFORMATION_MESSAGE, morpion.imagePodium);
			}
		};
		
		scores.addActionListener(fenscore);
		
		morpion.fen.pack();
		morpion.fen.setVisible(true);
		morpion.fen.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		
	}
}
